diff --git a/gcc/cp/decl.cc b/gcc/cp/decl.cc
index 6d20765f40c..4665a29a24d 100644
--- a/gcc/cp/decl.cc
+++ b/gcc/cp/decl.cc
@@ -12407,14 +12407,20 @@ grokdeclarator (const cp_declarator *declarator,
 
   if (cxx_dialect >= cxx17 && type && is_auto (type)
       && innermost_code != cdk_function
+      /* Placeholder in parm gets a better error below.  */
+      && !(decl_context == PARM || decl_context == CATCHPARM)
       && id_declarator && declarator != id_declarator)
     if (tree tmpl = CLASS_PLACEHOLDER_TEMPLATE (type))
-    {
-      error_at (typespec_loc, "template placeholder type %qT must be followed "
-		"by a simple declarator-id", type);
-      inform (DECL_SOURCE_LOCATION (tmpl), "%qD declared here", tmpl);
-      type = error_mark_node;
-    }
+      {
+	auto_diagnostic_group g;
+	gcc_rich_location richloc (typespec_loc);
+	richloc.add_fixit_insert_after ("<>");
+	error_at (&richloc, "missing template argument list after %qE; "
+		  "for deduction, template placeholder must be followed "
+		  "by a simple declarator-id", tmpl);
+	inform (DECL_SOURCE_LOCATION (tmpl), "%qD declared here", tmpl);
+	type = error_mark_node;
+      }
 
   staticp = 0;
   inlinep = decl_spec_seq_has_spec_p (declspecs, ds_inline);
@@ -12892,6 +12898,7 @@ grokdeclarator (const cp_declarator *declarator,
 		  {
 		    if (!funcdecl_p || !dguide_name_p (unqualified_id))
 		      {
+			auto_diagnostic_group g;
 			error_at (typespec_loc, "deduced class "
 				  "type %qD in function return type",
 				  DECL_NAME (tmpl));
@@ -13837,12 +13844,15 @@ grokdeclarator (const cp_declarator *declarator,
 	      else if (tree c = CLASS_PLACEHOLDER_TEMPLATE (auto_node))
 		{
 		  auto_diagnostic_group g;
-		  error_at (typespec_loc,
-			    "class template placeholder %qE not permitted "
-			    "in this context", c);
+		  gcc_rich_location richloc (typespec_loc);
+		  richloc.add_fixit_insert_after ("<>");
+		  error_at (&richloc,
+			    "missing template argument list after %qE; template "
+			    "placeholder not permitted in parameter", c);
 		  if (decl_context == PARM && cxx_dialect >= cxx20)
-		    inform (typespec_loc, "use %<auto%> for an "
+		    inform (typespec_loc, "or use %<auto%> for an "
 			    "abbreviated function template");
+		  inform (DECL_SOURCE_LOCATION (c), "%qD declared here", c);
 		}
 	      else
 		error_at (typespec_loc,
diff --git a/gcc/cp/parser.cc b/gcc/cp/parser.cc
index 289c2142e45..841ba6ed997 100644
--- a/gcc/cp/parser.cc
+++ b/gcc/cp/parser.cc
@@ -24397,8 +24397,11 @@ cp_parser_type_id_1 (cp_parser *parser, cp_parser_flags flags,
 		location_t loc = type_specifier_seq.locations[ds_type_spec];
 		if (tree tmpl = CLASS_PLACEHOLDER_TEMPLATE (auto_node))
 		  {
-		    error_at (loc, "missing template arguments after %qT",
-			      auto_node);
+		    auto_diagnostic_group g;
+		    gcc_rich_location richloc (loc);
+		    richloc.add_fixit_insert_after ("<>");
+		    error_at (&richloc, "missing template arguments after %qE",
+			      tmpl);
 		    inform (DECL_SOURCE_LOCATION (tmpl), "%qD declared here",
 			    tmpl);
 		  }
diff --git a/gcc/testsuite/g++.dg/cpp1z/class-deduction113.C b/gcc/testsuite/g++.dg/cpp1z/class-deduction113.C
new file mode 100644
index 00000000000..8f6908e2746
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp1z/class-deduction113.C
@@ -0,0 +1,5 @@
+// PR c++/106793
+
+template <class T> struct A { A(T); };
+template <class T> void f(A *a); // { dg-error "placeholder.*parameter" "" { target c++17 } }
+// { dg-error "" "" { target c++14_down } .-1 }
diff --git a/gcc/testsuite/g++.dg/cpp23/auto-array2.C b/gcc/testsuite/g++.dg/cpp23/auto-array2.C
index 06431685b30..3fc2eae3cea 100644
--- a/gcc/testsuite/g++.dg/cpp23/auto-array2.C
+++ b/gcc/testsuite/g++.dg/cpp23/auto-array2.C
@@ -5,7 +5,7 @@ template<class T> struct A { A(); };
 A<int> a[3];
 auto (*p)[3] = &a;
 A<int> (*p2)[3] = &a;
-A (*p3)[3] = &a; // { dg-error "template placeholder type" }
+A (*p3)[3] = &a; // { dg-error "template placeholder" }
 auto (&r)[3] = a;
 A<int> (&r2)[3] = a;
-A (&r3)[3] = a; // { dg-error "template placeholder type" }
+A (&r3)[3] = a; // { dg-error "template placeholder" }